<template>
    <div id="playerCards">
        <div class="row text-center">
            <div class="column d-flex justify-content-center" v-for="card in cards" :key="card.id">
                <img v-if="canSelectCard" class="card" v-bind:src="getCard(card.fileName)"
                v-on:click="selectCard(card.id)" alt="mypic"/> 
                <img v-else class="card" v-bind:src="getCard(card.fileName)" alt="mypic"/> 
            </div>
        </div>
    </div>
</template>

<script>
    import axios from 'axios'; 
    export default {
        name: "playerCards",
        props: ['canSelectCard', 'isStoryteller'],
        data: function () {
            return {
                cards: [],
                playerId: this.$route.params.playerId,
                gameId: this.$route.params.gameId,
                roundId: this.$route.params.roundId,
                selectedCardParams: null
            };
        },
        methods: {
            generateCards() {
                axios.get("https://localhost:44361/api/card/player/" + this.playerId + "/game/" + this.gameId + "/generateCards");
            },
            retrieveCardAddresses() {
                axios.get("https://localhost:44361/api/card/player/" +
                    this.playerId + "/game/" + this.gameId).then(response => this.cards = response.data);
            },
            getCard(address) {
                return require('../assets/' + address);
            },
            selectCard(cardId) {
                axios.post("https://localhost:44361/api/card/chosenCard", {
                    chosenCardId: cardId,
                    roundId: this.roundId
                }).then(response => this.redirect(cardId, response));
            },
            redirect(cardId, response) {
                this.selectedCardParams = {
                    playerId: this.playerId,
                    gameId: this.gameId,
                    roundId: this.roundId,
                    cardId: cardId
                }
                console.log(response);
                if (this.isStoryteller) {
                    this.$router.push({ name: 'selectedCard', params: this.selectedCardParams });
                }
                else {
                    this.$router.push({ name: 'waitForOtherSelection', params: this.selectedCardParams });
                }
            },
            },
        created: async function () {
            this.retrieveCardAddresses();
        }
    }
</script>

<style scoped>
    .card {
        height: 250px;
        display: flex;
    }
    .column {
        float: left;
        width: 33.33%;
        padding: 5px;
    }
    #playerCards {
        background: #CCD6F3;
    }
</style>
